pcl::RGBPlaneCoefficientComparator< PointT, PointNT > Class Template Reference

RGBPlaneCoefficientComparator is a Comparator that operates on plane coefficients, for use in planar segmentation. More...

`#include <pcl/segmentation/rgb_plane_coefficient_comparator.h>`

Inheritance diagram for pcl::RGBPlaneCoefficientComparator< PointT, PointNT >:

## Public Types

typedef Comparator< PointT >::PointCloud | PointCloud
typedef Comparator< PointT >::PointCloudConstPtr | PointCloudConstPtr
typedef pcl::PointCloud< PointNT > | PointCloudN
typedef PointCloudN::Ptr | PointCloudNPtr
typedef PointCloudN::ConstPtr | PointCloudNConstPtr
typedef boost::shared_ptr< RGBPlaneCoefficientComparator< PointT, PointNT > > | Ptr
typedef boost::shared_ptr< const RGBPlaneCoefficientComparator< PointT, PointNT > > | ConstPtr
Public Types inherited from pcl::PlaneCoefficientComparator< PointT, PointNT >
typedef Comparator< PointT >::PointCloud | PointCloud
typedef Comparator< PointT >::PointCloudConstPtr | PointCloudConstPtr
typedef pcl::PointCloud< PointNT > | PointCloudN
typedef PointCloudN::Ptr | PointCloudNPtr
typedef PointCloudN::ConstPtr | PointCloudNConstPtr
typedef boost::shared_ptr< PlaneCoefficientComparator< PointT, PointNT > > | Ptr
typedef boost::shared_ptr< const PlaneCoefficientComparator< PointT, PointNT > > | ConstPtr
Public Types inherited from pcl::Comparator< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< Comparator< PointT > > | Ptr
typedef boost::shared_ptr< const Comparator< PointT > > | ConstPtr

## Public Member Functions

| RGBPlaneCoefficientComparator ()
| Empty constructor for RGBPlaneCoefficientComparator. More...
| RGBPlaneCoefficientComparator (boost::shared_ptr< std::vector< float > > &plane_coeff_d)
| Constructor for RGBPlaneCoefficientComparator. More...
virtual | ~RGBPlaneCoefficientComparator ()
| Destructor for RGBPlaneCoefficientComparator. More...
void | setColorThreshold (float color_threshold)
| Set the tolerance in color space between neighboring points, to be considered part of the same plane. More...
float | getColorThreshold () const
| Get the color threshold between neighboring points, to be considered part of the same plane. More...
bool | compare (int idx1, int idx2) const
| Compare two neighboring points, by using normal information, euclidean distance, and color information. More...
Public Member Functions inherited from pcl::PlaneCoefficientComparator< PointT, PointNT >
| PlaneCoefficientComparator ()
| Empty constructor for PlaneCoefficientComparator. More...
| PlaneCoefficientComparator (boost::shared_ptr< std::vector< float > > &plane_coeff_d)
| Constructor for PlaneCoefficientComparator. More...
virtual | ~PlaneCoefficientComparator ()
| Destructor for PlaneCoefficientComparator. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Set the input cloud for the comparator. More...
void | setInputNormals (const PointCloudNConstPtr &normals)
| Provide a pointer to the input normals. More...
PointCloudNConstPtr | getInputNormals () const
| Get the input normals. More...
void | setPlaneCoeffD (boost::shared_ptr< std::vector< float > > &plane_coeff_d)
| Provide a pointer to a vector of the d-coefficient of the planes' hessian normal form. More...
void | setPlaneCoeffD (std::vector< float > &plane_coeff_d)
| Provide a pointer to a vector of the d-coefficient of the planes' hessian normal form. More...
const std::vector< float > & | getPlaneCoeffD () const
| Get a pointer to the vector of the d-coefficient of the planes' hessian normal form. More...
virtual void | setAngularThreshold (float angular_threshold)
| Set the tolerance in radians for difference in normal direction between neighboring points, to be considered part of the same plane. More...
float | getAngularThreshold () const
| Get the angular threshold in radians for difference in normal direction between neighboring points, to be considered part of the same plane. More...
void | setDistanceThreshold (float distance_threshold, bool depth_dependent=false)
| Set the tolerance in meters for difference in perpendicular distance (d component of plane equation) to the plane between neighboring points, to be considered part of the same plane. More...
float | getDistanceThreshold () const
| Get the distance threshold in meters (d component of plane equation) between neighboring points, to be considered part of the same plane. More...
Public Member Functions inherited from pcl::Comparator< PointT >
| Comparator ()
| Empty constructor for comparator. More...
virtual | ~Comparator ()
| Empty destructor for comparator. More...
virtual PointCloudConstPtr | getInputCloud () const
| Get the input cloud this comparator operates on. More...

## Protected Attributes

float | color_threshold_
Protected Attributes inherited from pcl::PlaneCoefficientComparator< PointT, PointNT >
PointCloudNConstPtr | normals_
boost::shared_ptr< std::vector< float > > | plane_coeff_d_
float | angular_threshold_
float | distance_threshold_
bool | depth_dependent_
Eigen::Vector3f | z_axis_
Protected Attributes inherited from pcl::Comparator< PointT >
PointCloudConstPtr | input_

## Detailed Description

### template<typename PointT, typename PointNT>
class pcl::RGBPlaneCoefficientComparator< PointT, PointNT >

RGBPlaneCoefficientComparator is a Comparator that operates on plane coefficients, for use in planar segmentation.

Also takes into account RGB, so we can segmented different colored co-planar regions. In conjunction with OrganizedConnectedComponentSegmentation, this allows planes to be segmented from organized data.

Author
  Alex Trevor

Definition at line 55 of file rgb_plane_coefficient_comparator.h.

## Member Typedef Documentation

template<typename PointT , typename PointNT >

typedef boost::shared_ptr<const RGBPlaneCoefficientComparator<PointT, PointNT> > pcl::RGBPlaneCoefficientComparator< PointT, PointNT >::ConstPtr

Definition at line 66 of file rgb_plane_coefficient_comparator.h.

template<typename PointT , typename PointNT >

typedef Comparator<PointT>::PointCloud pcl::RGBPlaneCoefficientComparator< PointT, PointNT >::PointCloud

Definition at line 58 of file rgb_plane_coefficient_comparator.h.

template<typename PointT , typename PointNT >

typedef Comparator<PointT>::PointCloudConstPtr pcl::RGBPlaneCoefficientComparator< PointT, PointNT >::PointCloudConstPtr

Definition at line 59 of file rgb_plane_coefficient_comparator.h.

template<typename PointT , typename PointNT >

typedef pcl::PointCloud<PointNT> pcl::RGBPlaneCoefficientComparator< PointT, PointNT >::PointCloudN

Definition at line 61 of file rgb_plane_coefficient_comparator.h.

template<typename PointT , typename PointNT >

typedef PointCloudN::ConstPtr pcl::RGBPlaneCoefficientComparator< PointT, PointNT >::PointCloudNConstPtr

Definition at line 63 of file rgb_plane_coefficient_comparator.h.

template<typename PointT , typename PointNT >

typedef PointCloudN::Ptr pcl::RGBPlaneCoefficientComparator< PointT, PointNT >::PointCloudNPtr

Definition at line 62 of file rgb_plane_coefficient_comparator.h.

template<typename PointT , typename PointNT >

typedef boost::shared_ptr<RGBPlaneCoefficientComparator<PointT, PointNT> > pcl::RGBPlaneCoefficientComparator< PointT, PointNT >::Ptr

Definition at line 65 of file rgb_plane_coefficient_comparator.h.

## Constructor & Destructor Documentation

template<typename PointT , typename PointNT >

pcl::RGBPlaneCoefficientComparator< PointT, PointNT >::RGBPlaneCoefficientComparator | ( |  | ) |

inline

Empty constructor for RGBPlaneCoefficientComparator.

Definition at line 74 of file rgb_plane_coefficient_comparator.h.

template<typename PointT , typename PointNT >

pcl::RGBPlaneCoefficientComparator< PointT, PointNT >::RGBPlaneCoefficientComparator | ( | boost::shared_ptr< std::vector< float > > & | plane_coeff_d | ) |

inline

Constructor for RGBPlaneCoefficientComparator.

Parameters

  [in] | plane_coeff_d | a reference to a vector of d coefficients of plane equations. Must be the same size as the input cloud and input normals. a, b, and c coefficients are in the input normals.

Definition at line 82 of file rgb_plane_coefficient_comparator.h.

template<typename PointT , typename PointNT >

virtual pcl::RGBPlaneCoefficientComparator< PointT, PointNT >::~RGBPlaneCoefficientComparator | ( |  | ) |

inline virtual

Destructor for RGBPlaneCoefficientComparator.

Definition at line 89 of file rgb_plane_coefficient_comparator.h.

## Member Function Documentation

template<typename PointT , typename PointNT >

bool pcl::RGBPlaneCoefficientComparator< PointT, PointNT >::compare | ( | int | idx1,
|  | int | idx2
| ) |  | const

inline virtual

Compare two neighboring points, by using normal information, euclidean distance, and color information.

Parameters

  [in] | idx1 | The index of the first point.
  [in] | idx2 | The index of the second point.

Reimplemented from pcl::PlaneCoefficientComparator< PointT, PointNT >.

Definition at line 114 of file rgb_plane_coefficient_comparator.h.

References pcl::PlaneCoefficientComparator< PointT, PointNT >::angular_threshold_, pcl::RGBPlaneCoefficientComparator< PointT, PointNT >::color_threshold_, pcl::PlaneCoefficientComparator< PointT, PointNT >::distance_threshold_, pcl::Comparator< PointT >::input_, and pcl::PlaneCoefficientComparator< PointT, PointNT >::normals_.

template<typename PointT , typename PointNT >

float pcl::RGBPlaneCoefficientComparator< PointT, PointNT >::getColorThreshold | ( |  | ) | const

inline

Get the color threshold between neighboring points, to be considered part of the same plane.

Definition at line 104 of file rgb_plane_coefficient_comparator.h.

References pcl::RGBPlaneCoefficientComparator< PointT, PointNT >::color_threshold_.

template<typename PointT , typename PointNT >

void pcl::RGBPlaneCoefficientComparator< PointT, PointNT >::setColorThreshold | ( | float | color_threshold | ) |

inline

Set the tolerance in color space between neighboring points, to be considered part of the same plane.

Parameters

  [in] | color_threshold | The distance in color space

Definition at line 97 of file rgb_plane_coefficient_comparator.h.

References pcl::RGBPlaneCoefficientComparator< PointT, PointNT >::color_threshold_.

## Member Data Documentation

template<typename PointT , typename PointNT >

float pcl::RGBPlaneCoefficientComparator< PointT, PointNT >::color_threshold_

protected

Definition at line 131 of file rgb_plane_coefficient_comparator.h.

Referenced by pcl::RGBPlaneCoefficientComparator< PointT, PointNT >::compare(), pcl::RGBPlaneCoefficientComparator< PointT, PointNT >::getColorThreshold(), and pcl::RGBPlaneCoefficientComparator< PointT, PointNT >::setColorThreshold().

The documentation for this class was generated from the following file:

- /build/pcl-0nnAvv/pcl-1.7.2/segmentation/include/pcl/segmentation/rgb_plane_coefficient_comparator.h